$c: (
  'g': #f7fafc #edf1f7 #e2e7f0 #cbd7e0 #a0abc0 #677490 #4a5268 #2d3448 #1a1e2c #0b1c54,
  'f': #fbf5ff #edd8fd #dcbcfa #c194f4 #a87ede #977ac2 #725794 #50386e #3d2957 #400180,
  'b': #edfeff #b3e4e6 #8ccfd1 #6badb3 #55919e #487982 #344c52 #273236 #112429 #003d52,
  'v': #f2fff5 #8feba4 #6ad481 #4fb86b #3ba161 #338650 #29573b #213b2d #0b2e19 #005727,
  'o': #fff9f0 #fee7c8 #fbc98d #f6a055 #fc8e3a #dd6418 #cc4e13 #9c3c1c #7b2f1a #c43800,
  'r': #fff6f5 #fedcd7 #febbb2 #fc8f81 #f57665 #e65740 #d93e25 #c42719 #9c221c #c51802,
  'd': #ffffff #f1f1f1 #e7e7e7 #d3d3d3 #acacac #767676 #545454 #363636 #1f1f1f #482826,
);

$bsClass: ('primary', 'secondary', 'dark', 'light', 'info', 'success', 'warning', 'danger', 'muted');

@function c($key, $index) {
  @return nth(map-get($c, $key), $index);
}

@function bs($item, $index) {
  @if $item == 'c' { // color
    @return c(nth(nth($bsColor, $index), 1), nth(nth($bsColor, $index), 2));
  }

  @if $item == 'c-1' { // letter
    @return c(nth(nth($bsColor, $index), 1), nth(nth($bsColor, $index), 2) - 1);
  }

  @if $item == 'c+1' { // letter
    @return c(nth(nth($bsColor, $index), 1), nth(nth($bsColor, $index), 2) + 1);
  }
}

$bsColor: (('f', 7), ('g', 7), ('g', 8), ('g', 2), ('b', 6), ('v', 6), ('o', 7), ('r', 8), ('d', 7));

$bgcolor: c(g, 3);

$primary: bs(c, 1);
$secondary: bs(c, 2);
$dark: bs(c, 3);
$light: bs(c, 4);
$info: bs(c, 5);
$success: bs(c, 6);
$warning: bs(c, 7);
$danger: bs(c, 8);
$muted: bs(c, 9);

$violet: c(f, 7);
$orange: c(o, 7);
$bleu: c(b, 7);
$rouge: c(r, 8);
$vert: c(v, 6);

/* -------------------------------------------------------------------------- */
/* New classes
  f = [f]iolet ; b = bleu ; v = vert ;  o = orange ; r = rouge ;
  g = gris ; l = light ; d = dark ;
  fb- = background ; fc- = color ; fd- = border */
:root {
  --f-primary: #{$primary};
  --f-secondary: #{$secondary};
  --f-dark: #{$dark};
  --f-light: #{$light};
  --f-info: #{$info};
  --f-success: #{$success};
  --f-warning: #{$warning};
  --f-danger: #{$danger};
  --f-muted: #{$muted};

  --f-violet: #{$violet};
  --f-orange: #{$orange};
  --f-bleu: #{$bleu};
  --f-rouge: #{$rouge};
  --f-vert: #{$vert};

  --f-body-bg: #{c(g, 3)};

  @each $key, $colors in $c {
    @for $i from 1 through 10 {
      --f-#{$key}#{$i}: #{nth($colors, $i)};
    }
  }
}

.violet { color: var(--f-violet); }
.orange { color: var(--f-orange); }
.bleu { color: var(--f-bleu); }
.rouge { color: var(--f-rouge); }
.vert { color: var(--f-vert); }

@each $key, $colors in $c {
  @for $i from 1 through 10 {
    .fc-#{$key}#{$i} {
      color: nth($colors, $i);
    }

    .fb-#{$key}#{$i} {
      background-color: nth($colors, $i);
    }

    .fd-#{$key}#{$i} {
      border-color: nth($colors, $i) !important;
    }
  }
}

.fc-light,
.fa-inverse,
.text-white {
  color: c(d, 1);
}

.fb-light {
  background-color: c(d, 1);
}

.fd-light {
  border-color: c(d, 1) !important;
}

.fc-dark,
.text-dark {
  color: c(d, 9);
}

.fb-dark {
  background-color: c(d, 9);
}

.fd-dark {
  border-color: c(d, 9) !important;
}

.fc-0 {
  color: transparent;
}

.fb-0 {
  background-color: transparent;
}

.fd-0 {
  border-color: transparent !important;
}
